/* Nintendulator - Win32 NES emulator written in C
 * Copyright (C) 2002-2008 QMT Productions
 *
 * $URL: https://nintendulator.svn.sourceforge.net/svnroot/nintendulator/nintendulator/trunk/src/Movie.h $
 * $Id: Movie.h 529 2008-07-28 03:17:05Z Quietust $
 */

#ifndef MOVIE_H
#define MOVIE_H

#define	MOV_PLAY	0x01
#define	MOV_RECORD	0x02
#define	MOV_REVIEW	0x04

struct tMovie
{
	unsigned char	Mode;
	FILE *		Data;
	unsigned char	ControllerTypes[4];
	int		ReRecords;
	TCHAR		Filename[MAX_PATH];
	int		Len;
	int		Pos;
	int		FrameLen;
};
extern struct tMovie Movie;

void		Movie_ShowFrame	(void);
void		Movie_Play	(BOOL);
void		Movie_Record	(BOOL);
void		Movie_Stop	(void);
unsigned char	Movie_LoadInput	(void);
void		Movie_SaveInput	(unsigned char);
int		Movie_Save	(FILE *);
int		Movie_Load	(FILE *);

#endif	/* !MOVIE_H */
